#!/bin/bash

. /etc/traffic_monitoring

recent_bytes=$(tail -n$recent_samples $logfile | /usr/local/bin/traffic_parse_stats.py | tail -1)
recent_MB=$(( $recent_bytes / 1024 / 1024 ))

if (($recent_MB >= $threshold_MB)); then
	/usr/sbin/sendmail -t <<EOM
To: $alert_recipients
Subject: Traffic alert for $(hostname): $recent_MB MB

Traffic alert:

Host $(hostname) has transferred $recent_MB MB in the last hour or so, on interface $interface.

(Sent by monitoring script $0 , using traffic data from $logfile .
Configuration and docs are in /etc/traffic_monitoring .)
EOM
fi
