#!/usr/bin/python

import fileinput

# SET SAMPLE LENGTH IN SECONDS HERE
sample_length = 5.0*60

total_up = 0
total_down = 0

print "time\tup\tdown\ttotal\taverage throughput (KiB/sec)"

previous_up = -1
previous_down = -1

for line in fileinput.input():
	line = line.split()
	down = int(line[4].split(':')[1])
	up = int(line[8].split(':')[1])

	# initialize from first sample, and don't print it
	if previous_up == -1:
		previous_up = up
		previous_down = down
		continue

	# rollover
	if up < previous_up:
		previous_up = 0
	if down < previous_down:
		previous_down = 0
	
	this_sample_up = (up - previous_up)
	this_sample_down = (down - previous_down)
	
	output_line = [
		" ".join(line[0:2]),             # date & time
		this_sample_up,                  # uploaded bytes
		this_sample_down,                # downloaded bytes
		this_sample_up+this_sample_down, # total bytes
		"%0.2f" % ((this_sample_up+this_sample_down)/sample_length/1024.0), # throughput in KiB/sec
	]
	print "\t".join(map(str,output_line))
	
	total_up += this_sample_up
	total_down += this_sample_down

	previous_up = up
	previous_down = down

# from http://stackoverflow.com/questions/1094841/reusable-library-to-get-human-readable-version-of-file-size
def sizeof_fmt(num):
	for x in ['bytes','KB','MB','GB']:
		if num < 1024.0 and num > -1024.0:
			return "%3.1f %s" % (num, x)
		num /= 1024.0
	return "%3.1f %s" % (num, 'TB')

print "=========================================================="
print "Up: " + sizeof_fmt(total_up)
print "Down: " + sizeof_fmt(total_down)
print "Total traffic: " + sizeof_fmt(total_up + total_down)
print "\nMachine-readable total:\n"+str(total_up + total_down)
